
package com.ibm.oti.reflect;

/*
 * Licensed Materials - Property of IBM,
 *     Copyright IBM Corp. 2010  All Rights Reserved
 */

import java.lang.annotation.Annotation;

final class Annotations {
	private final Annotation[] annotations;
	private final Class<? extends Annotation>[] annotationTypes;

	Annotations(Annotation[] annotations) {
		this.annotations = annotations;
		this.annotationTypes = new Class[annotations.length];
		for (int i = 0; i < annotations.length; i++) {
			annotationTypes[i] = annotations[i].annotationType();
		}
	}

	final <T extends Annotation> T getAnnotation(Class<T> cl) {
		for (int i = 0; i < annotationTypes.length; i++) {
			if (annotationTypes[i] == cl) {
				return (T)annotations[i];
			}
		}
		return null;
	}

	final Annotation[] getAnnotations() {
		return annotations;
	}
}
